unit Demo1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ODBCQry, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    Connection: TODBCCon;
    DemoQuery: TODBCQuery;
    CreateTable: TODBCQuery;
    InsertValues: TODBCQuery;
    Panel1: TPanel;
    Panel2: TPanel;
    Label4: TLabel;
    Memo1: TMemo;
    Panel3: TPanel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button1: TButton;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    Edit4: TEdit;
    Label5: TLabel;
    SpeedButton8: TSpeedButton;
    procedure Button1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure EditChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EditExit(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
  private
    { Private declarations }
    Edited: Boolean;
    procedure GetData;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses ODBCAPI;
{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
  RowNo: LongInt;
  MyDate: Date_Struct;
begin
  CreateTable.Execute;

  MyDate.Year := 1995;
  MyDate.Month := 7;

  with InsertValues do
  begin
    Prepared := True;
    for RowNo := 1 to 100 do
    begin
      Params[1].AsInteger := RowNo;
      Params[2].AsString := 'Row' + IntToStr(RowNo);
      MyDate.Day := RowNo mod 30 + 1;
      Params[3].AsDate := MyDate;
      Execute;
    end;
    Prepared := False;
  end;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  if ActiveControl <> Edit1 then Edit1.SetFocus
  else Edit2.SetFocus;
  if not DemoQuery.Active then DemoQuery.Active := True;
  DemoQuery.First;
  GetData;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  if ActiveControl <> Edit1 then Edit1.SetFocus
  else Edit2.SetFocus;
  if not DemoQuery.Active then DemoQuery.Active := True;
  DemoQuery.Prior;
  GetData;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  if ActiveControl <> Edit1 then Edit1.SetFocus
  else Edit2.SetFocus;
  if not DemoQuery.Active then DemoQuery.Active := True;
  DemoQuery.Next;
  GetData;
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  if ActiveControl <> Edit1 then Edit1.SetFocus
  else Edit2.SetFocus;
  if not DemoQuery.Active then DemoQuery.Active := True;
  DemoQuery.Last;
  GetData;
end;

procedure TForm1.SpeedButton6Click(Sender: TObject);
begin
  if ActiveControl <> Edit1 then Edit1.SetFocus
  else Edit2.SetFocus;
  if not DemoQuery.Active then DemoQuery.Active := True;
  DemoQuery.Delete;
  GetData;
end;

procedure TForm1.SpeedButton7Click(Sender: TObject);
begin
  if ActiveControl <> Edit1 then Edit1.SetFocus
  else Edit2.SetFocus;
  if not DemoQuery.Active then DemoQuery.Active := True;
  DemoQuery.Insert;
  GetData;
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
  if ActiveControl <> Edit1 then Edit1.SetFocus
  else Edit2.SetFocus;
  if not DemoQuery.Active then DemoQuery.Active := True;
  DemoQuery.Update;
  DemoQuery.ResetRows;
  GetData;
end;

procedure TForm1.GetData;
var
  Notes: TStrings;
begin
  with DemoQuery do
  begin
    Edit1.Text := FieldByName('MyKey').AsString;
    Edit2.Text := FieldByName('CharField').AsString;
    Edit3.Text := FieldByName('DateField').AsString;
    Notes := (FieldByName('Notes') as TODBCTextField).AsStrings;
    Memo1.Lines.Assign(Notes);
    Notes.Free;
    Edit4.Text := IntToStr(RecordNo);
  end;
  Edited := False;
end;

procedure TForm1.EditChange(Sender: TObject);
begin
  Edited := True;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Edited := False;
end;

procedure TForm1.EditExit(Sender: TObject);
begin
  if Edited then
  begin
    with DemoQuery do
    begin
      if Sender = Edit1 then FieldByName('MyKey').AsString := Edit1.Text;
      if Sender = Edit2 then FieldByName('CharField').AsString := Edit2.Text;
      if Sender = Edit3 then FieldByName('DateField').AsString := Edit3.Text;
      if Sender = Memo1 then (FieldByName('Notes') as TODBCTextField).AsStrings := Memo1.Lines;
    end;
  end;
  Edited := False;
end;

procedure TForm1.SpeedButton8Click(Sender: TObject);
begin
  if ActiveControl <> Edit1 then Edit1.SetFocus
  else Edit2.SetFocus;
  if not DemoQuery.Active then DemoQuery.Active := True;

  DemoQuery.RecordNo := StrToInt(Edit4.Text);
  GetData;
end;

end.
